import pyfits
import subprocess
import os

#################################################################################
def astrometry_image(file_name, Depth, Sigma, sip):
    print(file_name)
    Header  = pyfits.open(file_name)[0].header
    Ra = Header['RA']
    Dec = Header['DEC']
    
    shell = 'solve-field --ra '
    shell = shell+ Ra
    shell = shell+ ' --dec '
    shell = shell+ Dec
    shell = shell+ ' --radius '
    shell = shell+ '1'
    shell = shell+ ' --depth '
    shell = shell+ str(Depth)
    shell = shell+ ' --sigma '
    shell = shell+ str(Sigma)
    shell = shell+ ' -L '
    shell = shell+ '1.6'
    shell = shell+ ' -H '
    shell = shell+ '2.0'
    shell = shell+ ' -u app -O -p -r '
    if sip==0:
        shell = shell+ '-T'
    else:
        shell = shell+ '-t ' + str(int(sip))
    shell = shell+ ' -W none --no-fits2fits' #--guess-scale  --no-verify
    shell = shell+ ' -M none -R none -S none -P none -B none /cygdrive/' # -i none
    shell = shell+ file_name.replace(':','')
    shell = shell+ '\n'
    shell = 'C:\cygwin\\bin\mintty.exe /bin/bash -l ' + shell
    
##    print(shell)
    try:
        child = subprocess.run(shell, timeout=60)
        New_name = file_name.split('.')[0]+'_WCS.fits'
        os.rename(file_name.split('.')[0]+'.new', New_name)
        
        if(child.returncode==0 and os.path.isfile(New_name)):
            print('Astrometry: solved')
            os.remove(file_name.split('.')[0]+'.axy')
            os.remove(file_name.split('.')[0]+'-indx.xyls')
            os.remove(file_name)
            return True
        
        else:
            print ('Astrometry: error')
            return False
    except:
        print ('Astrometry: error')
        return False
        pass
        
def astrometry_all(Path2Data, Depth, Sigma, sip):
    ##create list of image files
    file_list = []
    dir_content = os.listdir(Path2Data)
    for ii in range (0,len(dir_content)):   ##read directory with images
        if dir_content[ii].count('.fit')==1 or dir_content[ii].count('.fts')==1 or dir_content[ii].count('.fits')==1:
            file_list.append(Path2Data + '/' + dir_content[ii])    

    ##check and calibrate
    if len(file_list)>0:
        for ii in range (0, len(file_list)):
            astrometry_image(file_list[ii], Depth, Sigma, sip)

#################################################################################
##astrometry for fits-table
def astrometry_table(file_name, Ra, Dec, sip):
    shell = 'solve-field --x-column XIMAGE --y-column YIMAGE --ra '
    shell = shell + str(Ra)
    shell = shell + ' --dec '
    shell = shell + str(Dec)
    shell = shell + ' --radius '
    shell = shell + '0.5'
    shell = shell + ' -L '
    shell = shell + '1.6'
    shell = shell + ' -H '
    shell = shell + '1.9'
    shell = shell + ' -u app -O -E 1 -p -r '
    if sip==0:
        shell = shell+ '-T'
    else:
        shell = shell+ '-t ' + str(int(sip))
    shell = shell + ' --depth '
    shell = shell + '50'
    shell = shell + ' --no-fits2fits -M none -R none -S none' ##--crpix-center'
    shell = shell + ' -P none -B none  -U none -N none /cygdrive/'
    shell = shell+ file_name.replace(':','')
    shell = shell+ '\n'    
    cshell = 'C:\cygwin\\bin\mintty.exe /bin/bash -l ' + shell

##    print(shell)
    try:
        startupinfo = subprocess.STARTUPINFO()
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW
        child = subprocess.run(cshell, timeout=60, startupinfo=startupinfo)
        New_name = file_name.split('.')[0]+'_WCS.fits'
        try:
            os.remove(New_name)
        except:
            pass
        os.rename(file_name.split('.')[0]+'.wcs', New_name)
        
        if(child.returncode==0 and os.path.isfile(New_name)):
            print('Astrometry: solved')
            os.remove(file_name.split('.')[0]+'.axy')
    ##        os.remove(file_name.split('.')[0]+'-indx.xyls')
            os.remove(file_name)
            return True
            
        else:
            print ('Astrometry: error')
            return False
    except:
        print ('Astrometry: error')
        return False
        pass
