##Cat_Data[:, 2:4] = B, e_B
##Cat_Data[:, 4:6] = V, e_V
##Cat_Data[:, 6:8] = g, e_g
##Cat_Data[:, 8:10] = r, e_r
##Cat_Data[:, 10:12] = i, e_i
from numpy import sqrt, column_stack
##from matplotlib import pyplot as plt

def get_Phot_Catalog(Filter, Cat_Data):
    if Filter == 'B':
        Out_Data = Cat_Data[:, 2:4]
        Out_Data = column_stack((Out_Data, Cat_Data[:, 2] - Cat_Data[:, 4]))
            
    elif Filter == 'V':
        Out_Data = Cat_Data[:, 4:6]
        Out_Data = column_stack((Out_Data, Cat_Data[:, 2] - Cat_Data[:, 4]))
        
    elif Filter == 'R':                     ##R = r-(0.272+-0.092)*(r-i) - (0.159+-0.022)
        mag = Cat_Data[:, 8] - 0.272*(Cat_Data[:, 8] - Cat_Data[:, 10]) - 0.159
        err = Cat_Data[:, 9]**2 + (0.272*0.272) * (Cat_Data[:, 9]**2 + Cat_Data[:, 11]**2) + 0.022**2 + (0.092*(Cat_Data[:, 8] - Cat_Data[:, 10]))**2        
        err = sqrt(err)
        Out_Data = column_stack((mag, err, Cat_Data[:, 2] - Cat_Data[:, 4]))
        
    elif Filter == 'I':                     ##I = i-(0.337+-0.191)(r-i) - (0.370+-0.041)
        mag = Cat_Data[:, 10] - 0.337*(Cat_Data[:, 8] - Cat_Data[:, 10]) - 0.37
        err = Cat_Data[:, 11]**2 + (0.337*0.337) * (Cat_Data[:, 9]**2 + Cat_Data[:, 11]**2) + 0.041**2 + (0.191*(Cat_Data[:, 8] - Cat_Data[:, 10]))**2        
        err = sqrt(err)
        Out_Data = column_stack((mag, err, Cat_Data[:, 2] - Cat_Data[:, 4]))
        
    else:
        Out_Data = None
        
    return Out_Data
